package org.netkernel.lang.groovy.endpoint;

import groovy.lang.Binding;
import org.codehaus.groovy.runtime.InvokerHelper;
import org.netkernel.lang.groovy.representation.CompiledGroovyRep;
import org.netkernel.layer0.meta.impl.SourcedArgumentMetaImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFRequestReadOnly;
import org.netkernel.layer0.nkf.NKFException;
import org.netkernel.layer0.nkf.impl.NKFContextImpl;
import org.netkernel.layer0.util.RequestScopeClassLoader;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.w3c.dom.Document;

public class GroovyRuntime extends StandardAccessorImpl
{
	public GroovyRuntime()
	{	this.declareThreadSafe();
		declareArgument(new SourcedArgumentMetaImpl("operator",null,null,new Class[] {CompiledGroovyRep.class}));
	}

	@Override
	public void onRequest(INKFRequestContext context) throws Exception
	{	if (context.getThisRequest().getVerb()==INKFRequestReadOnly.VERB_META)
		{	super.onMeta(context);
		}
		else
		{
			String script=context.getThisRequest().getArgumentValue("operator");
			((NKFContextImpl)context).setRuntimeSourceIdentifier(script);
			CompiledGroovyRep opt=(CompiledGroovyRep)context.source("arg:operator", CompiledGroovyRep.class);
			ClassLoader cl=new RequestScopeClassLoader(context.getKernelContext().getRequestScope());
			Thread.currentThread().setContextClassLoader(cl);
			Binding b=new Binding();
			b.setVariable("context", context);
			try
			{	InvokerHelper.createScript(opt.getCompiledScript(), b).run();
			}
			catch (Exception e)
			{	StackTraceElement[] stes=e.getStackTrace();
				int line=-1;
				for (int j=0; j<stes.length; j++)
				{	if (stes[j].getClassName().contains("GroovyRuntime") && j>0)
					{	
						line=stes[j-1].getLineNumber();
						break;
					}
				}
				
				String loc=script+" line:"+line;
				throw new NKFException("Unhandled Exception in GroovyRuntime",null,loc,e);
			}
		}
	}
}
