package org.netkernel.lang.groovy.representation;

import groovy.lang.Binding;

import org.codehaus.groovy.runtime.InvokerHelper;
import org.netkernel.layer0.nkf.INKFRequestContext;

public class CompiledGroovyRep
{
	private Class mGroovyScript;
	private String mScript=null;
	private int mScriptHashCode;
	
	public CompiledGroovyRep(Class aGroovyScript, String aScript, boolean debug)
	{	mGroovyScript=aGroovyScript;
		if(debug)
		{	mScript=aScript;			
		}
		mScriptHashCode=aScript.hashCode();
	}
	
	public Class getCompiledScript()
	{	return mGroovyScript;
	}
	
	public Object construct(INKFRequestContext context) throws Exception
	{	Binding b=new Binding();
		b.setVariable("context", context);
		return InvokerHelper.createScript(mGroovyScript, null).getMetaClass().invokeConstructor(new Object[]{b});
	}

	@Override
	public boolean equals(Object obj)
	{	return (obj instanceof CompiledGroovyRep) && mScriptHashCode==((CompiledGroovyRep)obj).mScriptHashCode;		
	}

	@Override
	public String toString()
	{	String result;
		if(mScript==null)
		{	result= "Enable Kernel debug mode to view the script associated with this compiled representation\n"+mGroovyScript.toString();		
		}
		else
		{	result=mScript;			
		}
		return result;
	}

	@Override
	public int hashCode()
	{	return mScriptHashCode^mGroovyScript.hashCode();
	}

}
